//////////////////////////////////////////////////////////////////////////////
//	Module		: ClsIsa.h													//
//	Function	: Base class for ISA/VME/PC104 Smart A/D boards.			//
//	Author		: Jim Lamberson												//
//////////////////////////////////////////////////////////////////////////////

#ifndef Def_ClsIsa
#define Def_ClsIsa

#include "ClsNonStd.h"

class ClsIsa : public ClsNonStd {
public:
	ClsIsa( short ProductID, long Adrs, short NumCh, const char *pSdcTbl, const char *pCmdTbl ) :
	  ClsNonStd( ProductID, Adrs, NumCh, pSdcTbl, pCmdTbl ) {}
protected:
	// Command functions.
	void			CmdClose			();
	void			CmdResetBoard		();
	unsigned char	CmdStatusFlagsGet	();
	// Helper functions.
	bool			ActiveALARM			();
	void			DeclareResponse		( short nBytes );
	void			HandshakeDatString	( short nBytes );
	bool			HandshakeWait		( const char mask, const char xormask, const double maxtime );
	char			InByteDirect		( long Adrs );
	void			OutByteDirect		( long Adrs, char Value );
	void			SendByte			( char val );
	// Hardware access functions that are provided by a derived class.
	virtual char	InByte				( long Adrs )				= 0;
	virtual void	OutByte				( long Adrs, char Value )	= 0;
};

#endif